# Robust Inverse Reinforcement Learning Through Bayesian Theory of Mind

Our implementation builds upon the code for [RAMBO](https://github.com/marc-rigter/rambo).

## Installation
1. Install [MuJoCo 2.1.0](https://github.com/deepmind/mujoco/releases) to `~/.mujoco/mujoco210`.
2. Create a conda environment and install RAMBO.
```
cd rambo
conda env create -f environment/rambo_env.yml
conda activate rambo
pip install -e .
```

## Usage
Configuration files can be found in `examples/config/`. For example, to run the hopper-medium task from the D4RL benchmark, use the following.

```
rambo run_example examples.development --config examples.config.birl.mujoco.hopper_medium_expert --seed 0 --gpus 1
```

Models and training stats can be found in ``./logs``